<div #gridViewportWrapper class="sqtm-grid-std-layout full-width flex-column">
  @if (gridDisplay$ | async; as gridDisplay) {
    <div
      #headersViewport
      class="sqtm-grid-header-viewport flex-fixed-size flex-row"
      [style.display]="computeHeadersDisplay(gridDisplay)"
      [style.height]="calculateHeadersHeight(gridDisplay)"
    >
      <div
        #leftHeaders
        class="flex-fixed-size sqtm-grid-std-layout"
        [style.width]="calculateViewportWidth('leftViewport', gridDisplay)"
        [attr.data-test-viewport-name]="'headerLeftViewport'"
      >
        <sqtm-core-grid-header-row
          class="full-height"
          [style.width]="calculateViewportWidth('leftViewport', gridDisplay)"
          [gridDisplay]="gridDisplay"
          [viewportName]="'leftViewport'"
        >
        </sqtm-core-grid-header-row>
      </div>
      <div
        #centerHeaders
        class="sqtm-grid-std-layout"
        [attr.data-test-viewport-name]="'headerMainViewport'"
        style="flex: 1"
      >
        <sqtm-core-grid-header-row
          #centerHeadersViewport
          [style.height]="calculateRowHeight(gridDisplay)"
          [gridDisplay]="gridDisplay"
          [viewportName]="'mainViewport'"
        >
        </sqtm-core-grid-header-row>
      </div>
      <div
        #rightHeaders
        class="sqtm-grid-std-layout flex-fixed-size"
        [attr.data-test-viewport-name]="'headerRightViewport'"
        [style.width]="calculateViewportWidth('rightViewport', gridDisplay)"
      >
        <sqtm-core-grid-header-row
          class="full-height"
          [style.width]="calculateViewportWidth('rightViewport', gridDisplay)"
          [gridDisplay]="gridDisplay"
          [viewportName]="'rightViewport'"
        >
        </sqtm-core-grid-header-row>
      </div>
      <div
        #headerScrollPlaceholder
        class="sqtm-grid-std-layout flex-fixed-size"
      ></div>
    </div>
    <div
      #gridViewport
      [sqtmCoreDraggableList]="gridDisplay.id"
      [draggedContentRenderer]="gridDisplay.draggedContentRenderer"
      [dropEnabled]="gridDisplay.enableInternalDrop"
      [restrictToInternalDrop]="true"
      (dragStart)="handleDragStart($event)"
      (dragOver)="handleDragOver($event)"
      (dragLeave)="handleDragLeave($event)"
      (drop)="handleDrop($event)"
      (dragCancel)="handleDragCancel($event)"
      class="sqtm-grid-std-layout flex-row full-width sqtm-grid-viewport"
      style="overflow: auto"
    >
      @if (gridNodes$ | async; as rows) {
        <div
          #leftViewport
          class="sqtm-grid-row-viewport flex-fixed-size"
          [style.width]="calculateViewportWidth('leftViewport', gridDisplay)"
          [style.height]="calculateViewportHeight(rows, gridDisplay)"
          [attr.data-test-viewport-name]="'leftViewport'"
        >
          <sqtm-core-grid-row-wrapper
            *sqtmCoreVirtualScrollFor="let row of rows; trackBy: trackByRowId"
            [style.width]="calculateViewportWidth('leftViewport', gridDisplay)"
            [style.height]="calculateRowHeight(gridDisplay)"
            style="min-width: 100%; position: absolute"
            [ngStyle]="getRowStyle(row, gridDisplay)"
            [gridNode]="row"
            [viewport]="gridDisplay.leftViewport"
            [gridDisplay]="gridDisplay"
          >
          </sqtm-core-grid-row-wrapper>
        </div>
        <div
          #centerClipper
          class="sqtm-grid-std-layout flex-row full-width"
          [style.height]="calculateViewportHeight(rows, gridDisplay)"
        >
          <div
            #centerViewport
            class="sqtm-grid-std-layout full-width"
            [style.overflow-y]="
              gridDisplay.gridType === 'TABLE' ? 'auto' : 'hidden'
            "
            [attr.data-test-viewport-name]="'mainViewport'"
          >
            <div
              #centerRowContainer
              style="min-width: 100%; position: relative"
              [style.height]="calculateViewportHeight(rows, gridDisplay)"
              [style.width]="calculateMainViewportWidth(gridDisplay)"
            >
              <sqtm-core-grid-row-wrapper
                *sqtmCoreVirtualScrollFor="
                  let row of rows;
                  trackBy: trackByRowId
                "
                [ngStyle]="getRowStyle(row, gridDisplay)"
                [gridNode]="row"
                [viewport]="gridDisplay.mainViewport"
                [gridDisplay]="gridDisplay"
              >
              </sqtm-core-grid-row-wrapper>
            </div>
          </div>
        </div>
        <div
          #rightViewport
          class="sqtm-grid-row-viewport flex-fixed-size"
          [style.width]="calculateViewportWidth('rightViewport', gridDisplay)"
          [style.height]="calculateViewportHeight(rows, gridDisplay)"
          [attr.data-test-viewport-name]="'rightViewport'"
        >
          <sqtm-core-grid-row-wrapper
            *sqtmCoreVirtualScrollFor="let row of rows; trackBy: trackByRowId"
            [style.width]="calculateViewportWidth('rightViewport', gridDisplay)"
            [style.height]="calculateRowHeight(gridDisplay)"
            style="min-width: 100%; position: absolute"
            [ngStyle]="getRowStyle(row, gridDisplay)"
            [gridNode]="row"
            [viewport]="gridDisplay.rightViewport"
            [gridDisplay]="gridDisplay"
          >
          </sqtm-core-grid-row-wrapper>
        </div>
      }
    </div>
    @if (globalAsyncOperationRunning$ | async) {
      <div class="async-overlay full-width">
        <i
          class="current-workspace-main-color"
          nz-icon
          nzType="loading"
          nzTheme="outline"
        ></i>
      </div>
    }
    <div
      class="full-height full-width flex-fixed-size flex-row"
      [style.height]="getScrollBarHeight()"
    >
      <div
        class="full-height flex-fixed-size"
        [attr.data-test-scroll-viewport-id]="'leftViewport'"
        [style.width]="calculateViewportWidth('leftViewport', gridDisplay)"
      ></div>
      <div
        #horizontalScroll
        [attr.data-test-scroll-viewport-id]="'mainViewport'"
        class="full-height"
        style="width: 100%; flex-shrink: 1; overflow: auto"
      >
        <div #horizontalScrollContent class="full-height"></div>
      </div>
      <div
        class="full-height flex-fixed-size"
        [attr.data-test-scroll-viewport-id]="'rightViewport'"
        [style.width]="calculateViewportWidth('rightViewport', gridDisplay)"
      ></div>
      <div
        class="full-height flex-fixed-size"
        [style.width]="getScrollBarWidth()"
      ></div>
    </div>
  }
</div>
